`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   15:52:27 02/10/2014
// Design Name:   sakura_w_vcp_mode
// Module Name:   sakura_w_vcp_mode.v
// Project Name:  sakura_w_vcp_mode
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: sakura_w_vcp_mode
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module sakura_w_vcp_mode_tb;

	// Inputs
	reg RSTn;
	reg CLK;
	reg USB_RXD;
	reg USB_RTSn;
	reg CARD_DETECT;
	reg CARD_AUX1;
	reg CARD_AUX2;
//	reg [3:0] W_DSW_IN;
	reg PUSH_SW;
//	reg [1:0] DIP_SW;

  // Outputs
  wire USB_TXD;
  wire USB_CTSn;
  wire CARD_RST;
  wire CARD_CLK;
  wire CARD_POWEN;
  wire gpio_txd;
  wire gpio_rxd;
  wire gpio_TRG0;
  wire gpio_TRG1;
  wire [3:0] W_LED_OUT;
  wire [7:0] LED;

  // Bidirs
  wire    CARD_IO;
  reg     CARD_IOin;
  assign  CARD_IO = CARD_IOin;

  // Instantiate the Unit Under Test (UUT)
  sakura_w_vcp_mode uut (
    .RSTn(RSTn), 
    .CLK(CLK), 
    .USB_RXD(USB_RXD), 
    .USB_TXD(USB_TXD), 
    .USB_RTSn(USB_RTSn), 
    .USB_CTSn(USB_CTSn), 
    .CARD_RST(CARD_RST), 
    .CARD_CLK(CARD_CLK), 
    .CARD_IO(CARD_IO), 
    .CARD_DETECT(CARD_DETECT), 
    .CARD_POWEN(CARD_POWEN), 
    .CARD_AUX1(CARD_AUX1), 
    .CARD_AUX2(CARD_AUX2), 
    .gpio_txd(gpio_txd), 
    .gpio_rxd(gpio_rxd), 
    .gpio_TRG0(gpio_trig0), 
    .gpio_TRG1(gpio_trig1), 
    .W_LED_OUT(W_LED_OUT), 
//    .W_DSW_IN(W_DSW_IN), 
    .LED(LED), 
    .PUSH_SW(PUSH_SW)
//    .DIP_SW(DIP_SW)
  );


  parameter STEP = 20.833;
  parameter ETU  = 16*STEP * 121 / 9;
//  parameter ETU  = 372;

  always begin
    CLK = 0; #(STEP/2);
    CLK = 1; #(STEP/2);
  end



  initial begin
  // Initialize Inputs
    RSTn = 0;
    USB_RXD = 1;
    USB_RTSn = 1;
    CARD_DETECT = 0;
    CARD_IOin = 1'bz;
    CARD_AUX1 = 0;
    CARD_AUX2 = 0;
//    W_DSW_IN = 0;
    PUSH_SW = 0;
//    DIP_SW = 2'b01;

  // Wait 1000 ns for global reset to finish
    #1000; RSTn = 1;
        
  // Add stimulus here
    #(STEP*5000); CARD_DETECT = 1;
    #(STEP*100);  USB_RTSn = 0;
    #(STEP*100);
      usb_rx( 8'h55 );
    #(STEP*100);
      card_rx( 8'h55 );
    #(STEP*100);


    #(STEP*3000);
    $stop;
    $finish;
  end


  task  usb_rx;
  input [7:0] data;
    begin
      #ETU USB_RXD = 1'b0;
      #ETU USB_RXD = data[0];
      #ETU USB_RXD = data[1];
      #ETU USB_RXD = data[2];
      #ETU USB_RXD = data[3];
      #ETU USB_RXD = data[4];
      #ETU USB_RXD = data[5];
      #ETU USB_RXD = data[6];
      #ETU USB_RXD = data[7];
      #ETU USB_RXD = 1'b1;
      #ETU;
    end
  endtask

  task  card_rx;
  input [7:0] data;
    begin
      #ETU CARD_IOin = 1'b0;
      #ETU CARD_IOin = data[0];
      #ETU CARD_IOin = data[1];
      #ETU CARD_IOin = data[2];
      #ETU CARD_IOin = data[3];
      #ETU CARD_IOin = data[4];
      #ETU CARD_IOin = data[5];
      #ETU CARD_IOin = data[6];
      #ETU CARD_IOin = data[7];
      #ETU CARD_IOin = 1'b1;
      #ETU CARD_IOin = 1'bz;
      #ETU;
    end
  endtask

 
endmodule

